#uses "fwUnitTestComponentAsserts.ctl"
#uses "test/fwRPC/utils.ctl"

#uses "fwRPC/fwRPC_core.ctl"
#uses "fwRPC/fwRPC_msgBroker.ctl"

public anytype _ctx;


void test_fwRPC_core_setupSuite() {
  _BEGIN_SUITE("core");
}

void test_fwRPC_core_teardownSuite() {
  if (fwRPC_msgBroker_isRunning() || fwRPC_msgClient_isRunning(_ctx)) {
    fwRPC_core_shutdown();
  }

  _END_SUITE();
}

void test_fwRPC_core_setup() {
  _BEGIN_TEST();
}

void test_fwRPC_core_teardown() {
  if (fwRPC_msgBroker_isRunning() || fwRPC_msgClient_isRunning(_ctx)) {
    fwRPC_core_shutdown();
  }
}


//------------------------------------------------------------------------------





//------------------------------------------------------------------------------


void test_fwRPC_core_initializes_and_shuts_down() {
  fwRPC_core_initialize(-1, -1, false, "d");

  assertTrue(fwRPC_msgBroker_isRunning());

  delay(1);
  fwRPC_core_shutdown();

  assertFalse(fwRPC_msgBroker_isRunning());

  fwRPC_core_initialize(-1, -1, true, "d");

  //this is what ctx actually is..
  _ctx = fwRPC_dist_buildClientName(false, fwRPC_DIST_TAG_CORE, "d");

  assertTrue(fwRPC_msgBroker_isRunning());
  assertTrue(fwRPC_msgClient_isRunning(_ctx));
  delay(1);

  fwRPC_core_shutdown();

  assertFalse(fwRPC_msgBroker_isRunning());
  assertFalse(fwRPC_msgClient_isRunning(_ctx));
}


void test_fwRPC_core_sends_disconnect_on_shutdown() {
  fwRPC_core_initialize(-1, -1, true, "d");

  string coreName = fwRPC_DIST_TAG_REMOTE + "_" + fwRPC_DIST_TAG_CORE + "_d";
  string rbDp = fwRPC_common_makeDpName(fwRPC_RBMBX_DPT, coreName);

  delay(1);
  fwRPC_core_shutdown();

  string id, type, proj, name;

  string val, buffer;
  assertEqual(0, fwRPC_RingBuffer_read(rbDp + ".out", val));
  fwRPC_common_unpackMessage(val, id, type, proj, name, buffer);

  assertEqual(fwRPC_DISTMSG_TYPE_DISCONNECT, type);
}
